"use strict";

require("core-js/modules/es.reflect.construct.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("regenerator-runtime/runtime.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/web.timers.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.array-buffer.slice.js");

require("core-js/modules/es.typed-array.uint8-array.js");

require("core-js/modules/es.typed-array.copy-within.js");

require("core-js/modules/es.typed-array.every.js");

require("core-js/modules/es.typed-array.fill.js");

require("core-js/modules/es.typed-array.filter.js");

require("core-js/modules/es.typed-array.find.js");

require("core-js/modules/es.typed-array.find-index.js");

require("core-js/modules/es.typed-array.for-each.js");

require("core-js/modules/es.typed-array.includes.js");

require("core-js/modules/es.typed-array.index-of.js");

require("core-js/modules/es.typed-array.iterator.js");

require("core-js/modules/es.typed-array.join.js");

require("core-js/modules/es.typed-array.last-index-of.js");

require("core-js/modules/es.typed-array.map.js");

require("core-js/modules/es.typed-array.reduce.js");

require("core-js/modules/es.typed-array.reduce-right.js");

require("core-js/modules/es.typed-array.reverse.js");

require("core-js/modules/es.typed-array.set.js");

require("core-js/modules/es.typed-array.slice.js");

require("core-js/modules/es.typed-array.some.js");

require("core-js/modules/es.typed-array.sort.js");

require("core-js/modules/es.typed-array.subarray.js");

require("core-js/modules/es.typed-array.to-locale-string.js");

require("core-js/modules/es.typed-array.to-string.js");

require("core-js/modules/es.object.set-prototype-of.js");

require("core-js/modules/es.object.get-prototype-of.js");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var EventEmitter = require('events');

var isUndefined = require('lodash.isundefined');

var ZitiSocket = /*#__PURE__*/function (_EventEmitter) {
  _inherits(ZitiSocket, _EventEmitter);

  var _super = _createSuper(ZitiSocket);

  function ZitiSocket(opts) {
    var _this;

    _classCallCheck(this, ZitiSocket);

    _this = _super.call(this);
    /**
     * 
     */

    _this.isWebSocket = false;

    if (typeof opts !== 'undefined') {
      if (typeof opts.isWebSocket !== 'undefined') {
        _this.isWebSocket = opts.isWebSocket;
      }
    }
    /**
     * This stream is where we'll put any data returned from a Ziti connection (see ziti_dial.data.call_back)
     */


    _this.readableZitiStream = new ReadableStream({
      start: function start(controller) {
        self.readableZitiStreamController = controller;
      }
    });
    /**
     * The underlying Ziti Connection
     * @private
     * @type {string}
     */

    _this.zitiConnection;
    /**
     * 
     */

    _this._writable = false;
    return _this;
  }
  /**
   * Make a connection to the specified Ziti 'service'.  We do this by invoking the ziti_dial() function in the Ziti NodeJS-SDK.
   * @param {*} service 
   */


  _createClass(ZitiSocket, [{
    key: "ziti_dial",
    value: function ziti_dial(service) {
      var _this2 = this;

      var self = this;
      return new Promise(function (resolve) {
        if (self.zitiConnection) {
          resolve(self.zitiConnection);
        } else {
          window.ziti.ziti_dial(service, self.isWebSocket,
          /**
           * on_connect callback.
           */
          function (conn) {
            // logger.info('on_connect callback: conn: %s', this.connAsHex(conn))
            resolve(conn);
          },
          /**
           * on_data callback
           */
          function (data) {
            conn.getCtx().logger.trace('on_data callback: conn: %s, data: \n%s', _this2.connAsHex(_this2.zitiConnection), data.toString());

            _this2.readableZitiStreamController.enqueue(data);
          });
        }
      });
    }
    /**
     * Write data onto the underlying Ziti connection by invoking the ziti_write() function in the Ziti NodeJS-SDK.  The
     * NodeJS-SDK expects incoming data to be of type Buffer.
    */

  }, {
    key: "ziti_write",
    value: function ziti_write(conn, buffer) {
      return new Promise(function (resolve) {
        window.ziti.ziti_write(conn, buffer, function () {
          resolve();
        });
      });
    }
    /**
     * 
     */

  }, {
    key: "captureResponseData",
    value: function captureResponseData(conn, data) {
      conn.getCtx().logger.trace("captureResponseData() <- conn: [%d], dataLen: [%o]", conn.getId(), data.byteLength); // conn.getCtx().logger.trace("captureResponseData() <- conn: [%d], data: [%o]", conn.getId(), data);

      var zitiSocket = conn.getSocket();
      conn.getCtx().logger.trace("captureResponseData() <- zitiSocket: [%o]", zitiSocket);

      if (data.byteLength > 0) {
        zitiSocket.emit('data', data);
      } else {
        zitiSocket.emit('close', data);
      }
    }
    /**
     * Connect to a Ziti service.
    */

  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(opts) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(_typeof(opts.conn) == 'object')) {
                  _context.next = 4;
                  break;
                }

                this.zitiConnection = opts.conn;
                _context.next = 12;
                break;

              case 4:
                if (!(typeof opts.serviceName == 'string')) {
                  _context.next = 11;
                  break;
                }

                this.zitiConnection = ziti.newConnection(ziti._ctx);
                _context.next = 8;
                return ziti.dial(this.zitiConnection, opts.serviceName);

              case 8:
                this.zitiConnection.getCtx().logger.debug("ZitiSocket: connect: dial(%s) on conn[%d] now complete", opts.serviceName, this.zitiConnection.getId());
                _context.next = 12;
                break;

              case 11:
                throw new Error('no serviceName or conn was provided');

              case 12:
                this._writable = true; // Prepare to capture response data from the request we are about to launch

                this.zitiConnection.setDataCallback(this.captureResponseData);
                this.zitiConnection.setSocket(this);
                this.emit('connect', this.zitiConnection);

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
    /**
     * 
     */

  }, {
    key: "_read",
    value: function _read() {
      /* NOP */
    }
  }, {
    key: "read",
    value: function read() {
      /* NOP */
    }
    /**
     * 
     */

  }, {
    key: "destroy",
    value:
    /**
     *
     */
    function () {
      var _destroy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this._writable = false;
                _context2.next = 3;
                return ziti.close(this.zitiConnection);

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function destroy() {
        return _destroy.apply(this, arguments);
      }

      return destroy;
    }()
    /**
     *
     */

  }, {
    key: "getZitiConnection",
    value:
    /**
     * Returna a Promise that will resolve _only_ after a Ziti connection has been established for this instance of ZitiSocket.
     */
    function getZitiConnection() {
      var self = this;
      return new Promise(function (resolve) {
        (function waitForConnected() {
          if (self.zitiConnection && !isUndefined(self.zitiConnection.getChannel())) return resolve(self.zitiConnection);
          setTimeout(waitForConnected, 10);
        })();
      });
    }
  }, {
    key: "connAsHex",
    value: function connAsHex(conn) {
      if (conn < 0) {
        conn = 0xFFFFFFFF + conn + 1;
      }

      return '0x' + conn.toString(16);
    }
    /**
     * Implements the writeable stream method `_write` by pushing the data onto the underlying Ziti connection.
     * It is possible that this function is called before the Ziti connect has completed, so this function will (currently)
     * await Ziti connection establishment (as opposed to buffering the data).
    */

  }, {
    key: "write",
    value: function () {
      var _write = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(chunk, encoding, cb) {
        var buffer, _conn, ch;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(typeof chunk === 'string' || chunk instanceof String)) {
                  _context3.next = 4;
                  break;
                }

                buffer = Buffer.from(chunk, 'utf8');
                _context3.next = 13;
                break;

              case 4:
                if (!Buffer.isBuffer(chunk)) {
                  _context3.next = 8;
                  break;
                }

                buffer = chunk;
                _context3.next = 13;
                break;

              case 8:
                if (!(chunk instanceof Uint8Array)) {
                  _context3.next = 12;
                  break;
                }

                buffer = Buffer.from(chunk, 'utf8');
                _context3.next = 13;
                break;

              case 12:
                throw new Error('chunk type of [' + _typeof(chunk) + '] is not a supported type');

              case 13:
                if (!(buffer.length > 0)) {
                  _context3.next = 19;
                  break;
                }

                _context3.next = 16;
                return this.getZitiConnection().catch(function (e) {
                  return _conn.getCtx().logger.error('inside ziti-socket.js _write(), Error 1: ', e.message);
                });

              case 16:
                _conn = _context3.sent;
                ch = _conn.getChannel(); // logger.info('_write: conn: %s, length: %s, data: \n%s', this.connAsHex(conn), buffer.byteLength, buffer.toString());
                // await this.ziti_write(conn, buffer).catch((e) => logger.error('_write(), Error 2: ', e.message));
                // let response = await 

                ch.write(_conn, buffer);

              case 19:
                if (cb) {
                  cb();
                }

              case 20:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function write(_x2, _x3, _x4) {
        return _write.apply(this, arguments);
      }

      return write;
    }()
    /**
     *
     */

  }, {
    key: "cork",
    value: function cork() {
      this._writable = false;
    }
  }, {
    key: "uncork",
    value: function uncork() {
      this._writable = true;
    }
    /**
     *
     */

  }, {
    key: "pause",
    value: function pause() {
      this._writable = false;
    }
  }, {
    key: "resume",
    value: function resume() {
      this._writable = true;
    }
  }, {
    key: "end",
    value: function () {
      var _end = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(data, encoding, callback) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                this._writable = false;
                _context4.next = 3;
                return ziti.close(this.zitiConnection);

              case 3:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function end(_x5, _x6, _x7) {
        return _end.apply(this, arguments);
      }

      return end;
    }()
    /**
     * Implements the writeable stream method `_final` used when .end() is called to write the final data to the stream.
     */

  }, {
    key: "_final",
    value: function _final(cb) {
      cb();
    }
    /**
     *
     */

  }, {
    key: "setTimeout",
    value: function setTimeout() {
      /* NOP */
    }
    /**
     *
     */

  }, {
    key: "setNoDelay",
    value: function setNoDelay() {
      /* NOP */
    }
    /**
     *
     */

  }, {
    key: "unshift",
    value: function unshift(head) {
      /* NOP */
    }
  }]);

  return ZitiSocket;
}(EventEmitter);

Object.defineProperty(ZitiSocket.prototype, 'writable', {
  get: function get() {
    return this._writable;
  }
});
/**
 * Module exports.
 */

module.exports = ZitiSocket;