/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
'use strict';

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.reflect.apply.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FreeList = /*#__PURE__*/function () {
  function FreeList(name, max, ctor) {
    _classCallCheck(this, FreeList);

    this.name = name;
    this.ctor = ctor;
    this.max = max;
    this.list = [];
  }

  _createClass(FreeList, [{
    key: "alloc",
    value: function alloc() {
      return this.list.length > 0 ? this.list.pop() : Reflect.apply(this.ctor, this, arguments);
    }
  }, {
    key: "free",
    value: function free(obj) {
      if (this.list.length < this.max) {
        this.list.push(obj);
        return true;
      }

      return false;
    }
  }]);

  return FreeList;
}();

module.exports = FreeList;