"use strict";

require("core-js/modules/es.reflect.construct.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

require("core-js/modules/es.promise.js");

require("regenerator-runtime/runtime.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/web.timers.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.object.set-prototype-of.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/web.url.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.match.js");

require("core-js/modules/es.string.starts-with.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.string.search.js");

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.string.split.js");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/*
Copyright 2019-2020 Netfoundry, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
var isUndefined = require('lodash.isundefined');

var EventEmitter = require('events');

var randomBytes = require('randombytes');

var createHash = require('create-hash');

var isNull = require('lodash.isnull');

var ZitiContext = require('../context/context');

var contextTypes = require('../context/contexttypes');

var LogLevel = require('../logLevels');

var HttpRequest = require('./request');

var HttpResponse = require('./response');

var http = require('./http');

var zitiConstants = require('../constants');

var ls = require('../utils/localstorage');

var Receiver = require('./receiver');

var Sender = require('./sender');

var PerMessageDeflate = require('./permessage-deflate');

var pjson = require('../../package.json');

var _require = require('./constants'),
    BINARY_TYPES = _require.BINARY_TYPES,
    EMPTY_BUFFER = _require.EMPTY_BUFFER,
    GUID = _require.GUID,
    kStatusCode = _require.kStatusCode,
    kWebSocket = _require.kWebSocket,
    NOOP = _require.NOOP;

var _require2 = require('./event-target'),
    addEventListener = _require2.addEventListener,
    removeEventListener = _require2.removeEventListener;

var readyStates = ['CONNECTING', 'OPEN', 'CLOSING', 'CLOSED'];
var protocolVersions = [8, 13];
var closeTimeout = 30 * 1000;
var handshakeTimeout = 5 * 1000;
/**
 * ZitiWebSocketWrapper:
 * 
 */

var ZitiWebSocketWrapper = /*#__PURE__*/function (_EventEmitter) {
  _inherits(ZitiWebSocketWrapper, _EventEmitter);

  var _super = _createSuper(ZitiWebSocketWrapper);

  /**
   * Create a new `ZitiWebSocketWrapper`.
   *
   * @param {(String|url.URL)} address The URL to which to connect
   * @param {(String|String[])} protocols The subprotocols
   * @param {Object} options Connection options
   */
  function ZitiWebSocketWrapper(address, protocols, options) {
    var _this;

    _classCallCheck(this, ZitiWebSocketWrapper);

    _this = _super.call(this);
    _this.readyState = ZitiWebSocketWrapper.CONNECTING;
    _this.protocol = '';
    _this._zitiInitialized = false;
    _this._binaryType = BINARY_TYPES[0];
    _this._closeFrameReceived = false;
    _this._closeFrameSent = false;
    _this._closeMessage = '';
    _this._closeTimer = null;
    _this._closeCode = 1006;
    _this._extensions = {};
    _this._receiver = null;
    _this._sender = null;
    _this._socket = null;

    if (address !== null) {
      _this._bufferedAmount = 0;
      _this._isServer = false;
      _this._redirects = 0;

      if (Array.isArray(protocols)) {
        protocols = protocols.join(', ');
      } else if (_typeof(protocols) === 'object' && protocols !== null) {
        options = protocols;
        protocols = undefined;
      }

      initAsClient(_assertThisInitialized(_this), address, protocols, options);
    } else {
      _this._isServer = true;
    }

    return _this;
  }

  _createClass(ZitiWebSocketWrapper, [{
    key: "CONNECTING",
    get: function get() {
      return ZitiWebSocketWrapper.CONNECTING;
    }
  }, {
    key: "CLOSING",
    get: function get() {
      return ZitiWebSocketWrapper.CLOSING;
    }
  }, {
    key: "CLOSED",
    get: function get() {
      return ZitiWebSocketWrapper.CLOSED;
    }
  }, {
    key: "OPEN",
    get: function get() {
      return ZitiWebSocketWrapper.OPEN;
    }
    /**
     * This deviates from the WHATWG interface since ws doesn't support the
     * required default "blob" type (instead we define a custom "nodebuffer"
     * type).
     *
     * @type {String}
     */

  }, {
    key: "binaryType",
    get: function get() {
      return this._binaryType;
    },
    set: function set(type) {
      if (!BINARY_TYPES.includes(type)) return;
      this._binaryType = type; //
      // Allow to change `binaryType` on the fly.
      //

      if (this._receiver) this._receiver._binaryType = type;
    }
    /**
     * @type {Number}
     */

  }, {
    key: "bufferedAmount",
    get: function get() {
      if (!this._socket) return this._bufferedAmount; //
      // `socket.bufferSize` is `undefined` if the socket is closed.
      //

      return (this._socket.bufferSize || 0) + this._sender._bufferedBytes;
    }
    /**
     * @type {String}
     */

  }, {
    key: "extensions",
    get: function get() {
      return Object.keys(this._extensions).join();
    }
    /**
     * Set up the socket and the internal resources.
     *
     * @param {net.Socket} socket The network socket between the server and client
     * @param {Buffer} head The first packet of the upgraded stream
     * @param {Number} maxPayload The maximum allowed message size
     * @private
     */

  }, {
    key: "setSocket",
    value: function setSocket(socket, head, maxPayload) {
      // ziti._ctx.logger.info('setSocket() entered, socket: %o', socket);
      var receiver = new Receiver(this._binaryType, this._extensions, this._isServer, maxPayload);
      this._sender = new Sender(socket, this._extensions);
      this._receiver = receiver;
      this._socket = socket;
      receiver[kWebSocket] = this;
      socket[kWebSocket] = this;
      receiver.on('conclude', receiverOnConclude);
      receiver.on('drain', receiverOnDrain);
      receiver.on('error', receiverOnError);
      receiver.on('message', receiverOnMessage);
      receiver.on('ping', receiverOnPing);
      receiver.on('pong', receiverOnPong);
      socket.setTimeout(0);
      socket.setNoDelay();
      if (head.length > 0) socket.unshift(head);
      socket.on('close', socketOnClose);
      socket.on('data', socketOnData);
      socket.on('end', socketOnEnd);
      socket.on('error', socketOnError);
      this.readyState = ZitiWebSocketWrapper.OPEN;
      this.emit('open');
    }
    /**
     * Emit the `'close'` event.
     *
     * @private
     */

  }, {
    key: "emitClose",
    value: function emitClose() {
      if (!this._socket) {
        //   ziti._ctx.logger.debug(
        //   'emitClose 1: _closeCode=%o, _closeMessage=%o',
        //   this._closeCode,
        //   this._closeMessage
        // );
        this.readyState = ZitiWebSocketWrapper.CLOSED;
        this.emit('close', this._closeCode, this._closeMessage);
        return;
      }

      if (this._extensions[PerMessageDeflate.extensionName]) {
        this._extensions[PerMessageDeflate.extensionName].cleanup();
      } // ziti._ctx.logger.debug(
      //   'emitClose 2: _closeCode=%o, _closeMessage=%o',
      //   this._closeCode,
      //   this._closeMessage
      // );


      this._receiver.removeAllListeners();

      this.readyState = ZitiWebSocketWrapper.CLOSED;
      this.emit('close', this._closeCode, this._closeMessage);
    }
    /**
     * Start a closing handshake.
     *
     *          +----------+   +-----------+   +----------+
     *     - - -|ws.close()|-->|close frame|-->|ws.close()|- - -
     *    |     +----------+   +-----------+   +----------+     |
     *          +----------+   +-----------+         |
     * CLOSING  |ws.close()|<--|close frame|<--+-----+       CLOSING
     *          +----------+   +-----------+   |
     *    |           |                        |   +---+        |
     *                +------------------------+-->|fin| - - - -
     *    |         +---+                      |   +---+
     *     - - - - -|fin|<---------------------+
     *              +---+
     *
     * @param {Number} code Status code explaining why the connection is closing
     * @param {String} data A string explaining why the connection is closing
     * @public
     */

  }, {
    key: "close",
    value: function close(code, data) {
      var _this2 = this;

      if (this.readyState === ZitiWebSocketWrapper.CLOSED) return;

      if (this.readyState === ZitiWebSocketWrapper.CONNECTING) {
        var msg = 'ZitiWebSocketWrapper was closed before the connection was established';
        return abortHandshake(this, this._req, msg);
      }

      if (this.readyState === ZitiWebSocketWrapper.CLOSING) {
        if (this._closeFrameSent && this._closeFrameReceived) this._socket.end();
        return;
      }

      this.readyState = ZitiWebSocketWrapper.CLOSING;

      this._sender.close(code, data, !this._isServer, function (err) {
        //
        // This error is handled by the `'error'` listener on the socket. We only
        // want to know if the close frame has been sent here.
        //
        if (err) return;
        _this2._closeFrameSent = true;
        if (_this2._closeFrameReceived) _this2._socket.end();
      }); //
      // Specify a timeout for the closing handshake to complete.
      //


      this._closeTimer = setTimeout(this._socket.destroy.bind(this._socket), closeTimeout);
    }
    /**
     * Send a ping.
     *
     * @param {*} data The data to send
     * @param {Boolean} mask Indicates whether or not to mask `data`
     * @param {Function} cb Callback which is executed when the ping is sent
     * @public
     */

  }, {
    key: "ping",
    value: function ping(data, mask, cb) {
      if (this.readyState === ZitiWebSocketWrapper.CONNECTING) {
        throw new Error('ZitiWebSocketWrapper is not open: readyState 0 (CONNECTING)');
      }

      if (typeof data === 'function') {
        cb = data;
        data = mask = undefined;
      } else if (typeof mask === 'function') {
        cb = mask;
        mask = undefined;
      }

      if (typeof data === 'number') data = data.toString();

      if (this.readyState !== ZitiWebSocketWrapper.OPEN) {
        sendAfterClose(this, data, cb);
        return;
      }

      if (mask === undefined) mask = !this._isServer;

      this._sender.ping(data || EMPTY_BUFFER, mask, cb);
    }
    /**
     * Send a pong.
     *
     * @param {*} data The data to send
     * @param {Boolean} mask Indicates whether or not to mask `data`
     * @param {Function} cb Callback which is executed when the pong is sent
     * @public
     */

  }, {
    key: "pong",
    value: function pong(data, mask, cb) {
      if (this.readyState === ZitiWebSocketWrapper.CONNECTING) {
        throw new Error('ZitiWebSocketWrapper is not open: readyState 0 (CONNECTING)');
      }

      if (typeof data === 'function') {
        cb = data;
        data = mask = undefined;
      } else if (typeof mask === 'function') {
        cb = mask;
        mask = undefined;
      }

      if (typeof data === 'number') data = data.toString();

      if (this.readyState !== ZitiWebSocketWrapper.OPEN) {
        sendAfterClose(this, data, cb);
        return;
      }

      if (mask === undefined) mask = !this._isServer;

      this._sender.pong(data || EMPTY_BUFFER, mask, cb);
    }
    /**
     * Send a data message.
     *
     * @param {*} data The message to send
     * @param {Object} options Options object
     * @param {Boolean} options.compress Specifies whether or not to compress
     *     `data`
     * @param {Boolean} options.binary Specifies whether `data` is binary or text
     * @param {Boolean} options.fin Specifies whether the fragment is the last one
     * @param {Boolean} options.mask Specifies whether or not to mask `data`
     * @param {Function} cb Callback which is executed when data is written out
     * @public
     */

  }, {
    key: "send",
    value: function send(data, options, cb) {
      if (this.readyState === ZitiWebSocketWrapper.CONNECTING) {
        throw new Error('ZitiWebSocketWrapper is not open: readyState 0 (CONNECTING)');
      }

      if (typeof options === 'function') {
        cb = options;
        options = {};
      }

      if (typeof data === 'make-socket.io-think-we-are-native') {
        /* nop */
      }

      if (typeof data === 'number') data = data.toString();

      if (this.readyState !== ZitiWebSocketWrapper.OPEN) {
        sendAfterClose(this, data, cb);
        return;
      }

      var opts = _objectSpread({
        binary: typeof data !== 'string',
        mask: !this._isServer,
        compress: true,
        fin: true
      }, options);

      if (!this._extensions[PerMessageDeflate.extensionName]) {
        opts.compress = false;
      }

      this._sender.send(data || EMPTY_BUFFER, opts, cb);
    }
    /**
     * Forcibly close the connection.
     *
     * @public
     */

  }, {
    key: "terminate",
    value: function terminate() {
      if (this.readyState === ZitiWebSocketWrapper.CLOSED) return;

      if (this.readyState === ZitiWebSocketWrapper.CONNECTING) {
        var msg = 'ZitiWebSocketWrapper was closed before the connection was established';
        return abortHandshake(this, this._req, msg);
      }

      if (this._socket) {
        this.readyState = ZitiWebSocketWrapper.CLOSING;

        this._socket.destroy();
      }
    }
  }]);

  return ZitiWebSocketWrapper;
}(EventEmitter);

readyStates.forEach(function (readyState, i) {
  ZitiWebSocketWrapper[readyState] = i;
}); //
// Add the `onopen`, `onerror`, `onclose`, and `onmessage` attributes.
// See https://html.spec.whatwg.org/multipage/comms.html#the-websocket-interface
//

['open', 'error', 'close', 'message'].forEach(function (method) {
  Object.defineProperty(ZitiWebSocketWrapper.prototype, "on".concat(method), {
    /**
     * Return the listener of the event.
     *
     * @return {(Function|undefined)} The event listener or `undefined`
     * @public
     */
    get: function get() {
      var listeners = this.listeners(method);

      for (var i = 0; i < listeners.length; i++) {
        if (listeners[i]._listener) return listeners[i]._listener;
      }

      return undefined;
    },

    /**
     * Add a listener for the event.
     *
     * @param {Function} listener The listener to add
     * @public
     */
    set: function set(listener) {
      var listeners = this.listeners(method);

      for (var i = 0; i < listeners.length; i++) {
        //
        // Remove only the listeners added via `addEventListener`.
        //
        if (listeners[i]._listener) this.removeListener(method, listeners[i]);
      }

      this.addEventListener(method, listener);
    }
  });
});
ZitiWebSocketWrapper.prototype.addEventListener = addEventListener;
ZitiWebSocketWrapper.prototype.removeEventListener = removeEventListener;
module.exports = ZitiWebSocketWrapper;
/**
 * Initialize a ZitiWebSocket client.
 *
 * @param {ZitiWebSocket} websocket The client to initialize
 * @param {(String|url.URL)} address The URL to which to connect
 * @param {String} protocols The subprotocols
 * @param {Object} options Connection options
 * @param {(Boolean|Object)} options.perMessageDeflate Enable/disable
 *     permessage-deflate
 * @param {Number} options.handshakeTimeout Timeout in milliseconds for the
 *     handshake request
 * @param {Number} options.protocolVersion Value of the `Sec-WebSocket-Version`
 *     header
 * @param {String} options.origin Value of the `Origin` or
 *     `Sec-WebSocket-Origin` header
 * @param {Number} options.maxPayload The maximum allowed message size
 * @param {Boolean} options.followRedirects Whether or not to follow redirects
 * @param {Number} options.maxRedirects The maximum number of redirects allowed
 * @private
 */

function initAsClient(_x, _x2, _x3, _x4) {
  return _initAsClient.apply(this, arguments);
}
/**
 *
 * @param {*} options
 */


function _initAsClient() {
  _initAsClient = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(websocket, address, protocols, options) {
    var serviceName, ctx, opts, parsedUrl, isUnixSocket, isSecure, defaultPort, key, get, perMessageDeflate, regex, newUrl, cookieString, zitiCookies, cookie, parts, request, req_options, req;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!isUndefined(ziti._ctx)) {
              _context.next = 6;
              break;
            }

            // If we have no context, create it now
            ctx = new ZitiContext(ZitiContext.prototype);
            _context.next = 4;
            return ctx.init({
              contextType: contextTypes.ClientType,
              logLevel: LogLevel[zitiConfig.httpAgent.zitiSDKjs.logLevel]
            });

          case 4:
            ctx.logger.success('JS SDK version %s init (ZitiWebSocketWrapper.initAsClient) completed', pjson.version);
            ziti._ctx = ctx;

          case 6:
            opts = _objectSpread(_objectSpread({
              enableTrace: true,
              protocolVersion: protocolVersions[1],
              maxPayload: 100 * 1024 * 1024,
              perMessageDeflate: true,
              followRedirects: false,
              maxRedirects: 10,
              href: address
            }, options), {}, {
              createConnection: undefined,
              socketPath: undefined,
              hostname: undefined,
              protocol: undefined,
              timeout: undefined,
              method: undefined,
              host: undefined,
              path: undefined,
              port: undefined
            });

            ziti._ctx.logger.info('ZitiWebSocketWrapper initAsClient(), address is: %s, options is: %o', address, opts); // /**
            //  *  Defer the Ziti init sequence for the moment.  We currently rely on
            //  *  ziti-electron-fetch component to have completed it for us.
            //  */
            // websocket.doZitiInitialization();
            // await websocket
            //   .isZitiInitialized()
            //   .catch((e) => logger.error('isZitiInitialized(), Error: ', e.message));


            if (protocolVersions.includes(opts.protocolVersion)) {
              _context.next = 10;
              break;
            }

            throw new RangeError("Unsupported protocol version: ".concat(opts.protocolVersion, " ") + "(supported versions: ".concat(protocolVersions.join(', '), ")"));

          case 10:
            if (address instanceof URL) {
              parsedUrl = address;
              websocket.url = address.href;
            } else {
              parsedUrl = new URL(address);
              websocket.url = address;
            }

            isUnixSocket = parsedUrl.protocol === 'ws+unix:';

            if (!(!parsedUrl.host && (!isUnixSocket || !parsedUrl.pathname))) {
              _context.next = 14;
              break;
            }

            throw new Error("Invalid URL: ".concat(websocket.url));

          case 14:
            isSecure = parsedUrl.protocol === 'wss:' || parsedUrl.protocol === 'https:';
            defaultPort = isSecure ? 443 : 80;
            key = randomBytes(16).toString('base64');
            get = http.get;
            // await loadCookies(parsedUrl.hostname);
            // We only want to intercept fetch requests that target the Ziti HTTP Agent
            regex = new RegExp(zitiConfig.httpAgent.self.host, 'g');

            if (!address.match(regex)) {
              _context.next = 29;
              break;
            }

            // the request is targeting the Ziti HTTP Agent
            newUrl = new URL(address);
            newUrl.hostname = zitiConfig.httpAgent.target.host;
            newUrl.port = zitiConfig.httpAgent.target.port; // ziti._ctx.logger.debug( 'ZitiWebSocketWrapper: transformed URL: ', newUrl.toString());

            _context.next = 25;
            return ziti._ctx.shouldRouteOverZiti(newUrl);

          case 25:
            serviceName = _context.sent;

            if (isUndefined(serviceName)) {
              // If we have no serviceConfig associated with the hostname:port, do not intercept
              // ziti._ctx.logger.warn('ZitiWebSocketWrapper(): no associated serviceConfig, bypassing intercept of [%s]', address);
              opts.createConnection = isSecure ? tlsConnect : netConnect;
              opts.host = parsedUrl.hostname.startsWith('[') ? parsedUrl.hostname.slice(1, -1) : parsedUrl.hostname;
            } else {
              opts.createConnection = zitiConnect; // We're going over Ziti

              newUrl.protocol = "http:";
              opts.href = newUrl.protocol + '//' + newUrl.host.toLowerCase() + newUrl.pathname + newUrl.search;
              opts.origin = "http://" + zitiConfig.httpAgent.target.host.toLowerCase();

              if (zitiConfig.httpAgent.target.port !== '80') {
                if (zitiConfig.httpAgent.target.port === '443') {
                  opts.origin = "https://" + zitiConfig.httpAgent.target.host.toLowerCase();
                } else {
                  opts.origin += ":" + zitiConfig.httpAgent.target.port;
                }
              }

              opts.host = zitiConfig.httpAgent.target.host + ":" + zitiConfig.httpAgent.target.port;
            }

            _context.next = 31;
            break;

          case 29:
            // the request is targeting the raw internet
            // ziti._ctx.logger.warn('ZitiWebSocketWrapper(): no associated serviceConfig, bypassing intercept of [%s]', address);
            opts.createConnection = isSecure ? tlsConnect : netConnect;
            opts.host = parsedUrl.hostname.startsWith('[') ? parsedUrl.hostname.slice(1, -1) : parsedUrl.hostname;

          case 31:
            opts.defaultPort = opts.defaultPort || defaultPort;
            opts.port = parsedUrl.port || defaultPort;
            opts.headers = _objectSpread({
              'Sec-WebSocket-Version': opts.protocolVersion,
              'Sec-WebSocket-Key': key,
              Connection: 'Upgrade',
              Upgrade: 'websocket'
            }, opts.headers);
            opts.path = parsedUrl.pathname + parsedUrl.search;
            cookieString = '';
            _context.next = 38;
            return ls.getWithExpiry(zitiConstants.get().ZITI_COOKIES);

          case 38:
            zitiCookies = _context.sent;

            if (!isNull(zitiCookies)) {
              for (cookie in zitiCookies) {
                if (zitiCookies.hasOwnProperty(cookie)) {
                  cookieString += cookie + '=' + zitiCookies[cookie] + '; ';
                }
              }
            }

            opts.headers.Cookie = cookieString;
            opts.timeout = opts.handshakeTimeout;

            if (!opts.timeout) {
              opts.timeout = handshakeTimeout;
            } // if (opts.perMessageDeflate) {
            //   perMessageDeflate = new PerMessageDeflate(
            //     opts.perMessageDeflate !== true ? opts.perMessageDeflate : {},
            //     false,
            //     opts.maxPayload
            //   );
            //   opts.headers['Sec-WebSocket-Extensions'] = format({
            //     [PerMessageDeflate.extensionName]: perMessageDeflate.offer()
            //   });
            // }


            if (protocols) {
              opts.headers['Sec-WebSocket-Protocol'] = protocols;
            }

            if (opts.origin) {
              if (opts.protocolVersion < 13) {
                opts.headers['Sec-WebSocket-Origin'] = opts.origin;
              } else {
                opts.headers.Origin = opts.origin;
              }
            }

            if (parsedUrl.username || parsedUrl.password) {
              opts.auth = "".concat(parsedUrl.username, ":").concat(parsedUrl.password);
            }

            if (isUnixSocket) {
              parts = opts.path.split(':');
              opts.socketPath = parts[0];
              opts.path = parts[1];
            } // build HTTP request object


            request = new HttpRequest(serviceName, opts.href, opts);
            _context.next = 50;
            return request.getRequestOptions();

          case 50:
            req_options = _context.sent;
            req_options.isWebSocket = true; // Send request

            req = websocket._req = get(req_options); // ziti._ctx.logger.info('WebSocket handshake request has been sent: %o', websocket._req);

            if (opts.timeout) {
              req.on('timeout', function () {
                // ziti._ctx.logger.info('req.on.timeout');
                abortHandshake(websocket, websocket._req, 'Opening handshake has timed out');
              });
            }

            req.on('error', function (err) {
              // ziti._ctx.logger.error('req.on.error %o', err);
              if (websocket._req.aborted) return;
              req = websocket._req = null;
              websocket.readyState = ZitiWebSocketWrapper.CLOSING;
              websocket.emit('error', err);
              websocket.emitClose();
            });
            req.on('response', function (res) {
              // ziti._ctx.logger.info('req.on.response %o', res);
              var location = res.headers.location;
              var statusCode = res.statusCode;

              if (location && opts.followRedirects && statusCode >= 300 && statusCode < 400) {
                if (++websocket._redirects > opts.maxRedirects) {
                  abortHandshake(websocket, req, 'Maximum redirects exceeded');
                  return;
                }

                req.abort();
                var addr = new URL(location, address);
                initAsClient(websocket, addr, protocols, options);
              } else if (!websocket.emit('unexpected-response', req, res)) {
                abortHandshake(websocket, req, "Unexpected server response: ".concat(res.statusCode));
              }
            });
            req.on('upgrade', function (res, socket, head) {
              // ziti._ctx.logger.info('WebSocket handshake on.upgrade \nsocket=[%o] \nHTTP Response=[%o]', socket, res);
              websocket.emit('upgrade', res); //
              // The user may have closed the connection from a listener of the `upgrade`
              // event.
              //

              if (websocket.readyState !== ZitiWebSocketWrapper.CONNECTING) return;
              req = websocket._req = null;
              var digest = createHash('sha1').update(key + GUID).digest('base64'); // ziti._ctx.logger.info(
              //     'WebSocket handshake on.upgrade\ndigest=%o\nheaders[sec-websocket-accept]=%o',
              //     digest,
              //     res.headers['sec-websocket-accept']
              // );

              if (res.headers['sec-websocket-accept'] !== digest) {
                abortHandshake(websocket, socket, 'Invalid Sec-WebSocket-Accept header');
                return;
              }

              var serverProt = res.headers['sec-websocket-protocol'];
              var protList = (protocols || '').split(/, */);
              var protError;

              if (!protocols && serverProt) {
                protError = 'Server sent a subprotocol but none was requested';
              } else if (protocols && !serverProt) {
                protError = 'Server sent no subprotocol';
              } else if (serverProt && !protList.includes(serverProt)) {
                protError = 'Server sent an invalid subprotocol';
              }

              if (protError) {
                // ziti._ctx.logger.error('protError=%o', protError);
                abortHandshake(websocket, socket, protError);
                return;
              }

              if (serverProt) websocket.protocol = serverProt;

              if (perMessageDeflate) {
                try {
                  var extensions = parse(res.headers['sec-websocket-extensions']);

                  if (extensions[PerMessageDeflate.extensionName]) {
                    perMessageDeflate.accept(extensions[PerMessageDeflate.extensionName]);
                    websocket._extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
                  }
                } catch (err) {
                  abortHandshake(websocket, socket, 'Invalid Sec-WebSocket-Extensions header');
                  return;
                }
              } // ziti._ctx.logger.info('WebSocket handshake SUCCESSFUL');


              websocket.setSocket(socket, head, opts.maxPayload);
            });

          case 57:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _initAsClient.apply(this, arguments);
}

function zitiConnect(options) {
  // ziti._ctx.logger.info('zitiConnect() entered: %o', options);
  options.path = undefined;

  if (!options.servername && options.servername !== '') {
    options.servername = options.host;
  }

  var socket = new ZitiSocket(ziti);
  socket.connect(options);
  logger.info('zitiConnect(): ZitiSocket is now connected to Ziti network: \n%o', socket);
  options.socket = socket;
  return socket;
}
/**
 * Abort the handshake and emit an error.
 *
 * @param {ZitiWebSocketWrapper} websocket The ZitiWebSocketWrapper instance
 * @param {(http.ClientRequest|net.Socket)} stream The request to abort or the
 *     socket to destroy
 * @param {String} message The error message
 * @private
 */


function abortHandshake(websocket, stream, message) {
  // ziti._ctx.logger.error(
  //   'abortHandshake() entered: message: %o, stream: %o',
  //   message,
  //   stream
  // );
  websocket.readyState = ZitiWebSocketWrapper.CLOSING;
  var err = new Error(message);
  Error.captureStackTrace(err, abortHandshake);

  if (isUndefined(stream)) {
    return;
  }

  if (stream.setHeader) {
    stream.abort();
    stream.once('abort', websocket.emitClose.bind(websocket));
    websocket.emit('error', err);
  } else {
    stream.destroy(err);
    stream.once('error', websocket.emit.bind(websocket, 'error'));
    stream.once('close', websocket.emitClose.bind(websocket));
  }
}
/**
 * Handle cases where the `ping()`, `pong()`, or `send()` methods are called
 * when the `readyState` attribute is `CLOSING` or `CLOSED`.
 *
 * @param {ZitiWebSocketWrapper} websocket The ZitiWebSocketWrapper instance
 * @param {*} data The data to send
 * @param {Function} cb Callback
 * @private
 */


function sendAfterClose(websocket, data, cb) {
  if (data) {
    var length = toBuffer(data).length; //
    // The `_bufferedAmount` property is used only when the peer is a client and
    // the opening handshake fails. Under these circumstances, in fact, the
    // `setSocket()` method is not called, so the `_socket` and `_sender`
    // properties are set to `null`.
    //

    if (websocket._socket) websocket._sender._bufferedBytes += length;else websocket._bufferedAmount += length;
  }

  if (cb) {
    var err = new Error("ZitiWebSocketWrapper is not open: readyState ".concat(websocket.readyState, " ") + "(".concat(readyStates[websocket.readyState], ")"));
    cb(err);
  }
}
/**
 * The listener of the `Receiver` `'conclude'` event.
 *
 * @param {Number} code The status code
 * @param {String} reason The reason for closing
 * @private
 */


function receiverOnConclude(code, reason) {
  var websocket = this[kWebSocket];

  websocket._socket.removeListener('data', socketOnData);

  websocket._socket.resume();

  websocket._closeFrameReceived = true;
  websocket._closeMessage = reason;
  websocket._closeCode = code;
  if (code === 1005) websocket.close();else websocket.close(code, reason);
}
/**
 * The listener of the `Receiver` `'drain'` event.
 *
 * @private
 */


function receiverOnDrain() {
  this[kWebSocket]._socket.resume();
}
/**
 * The listener of the `Receiver` `'error'` event.
 *
 * @param {(RangeError|Error)} err The emitted error
 * @private
 */


function receiverOnError(err) {
  var websocket = this[kWebSocket];

  websocket._socket.removeListener('data', socketOnData);

  websocket.readyState = ZitiWebSocketWrapper.CLOSING;
  websocket._closeCode = err[kStatusCode];
  websocket.emit('error', err);

  websocket._socket.destroy();
}
/**
 * The listener of the `Receiver` `'finish'` event.
 *
 * @private
 */


function receiverOnFinish() {
  // ziti._ctx.logger.info('receiverOnFinish() entered');
  this[kWebSocket].emitClose();
}
/**
 * The listener of the `Receiver` `'message'` event.
 *
 * @param {(String|Buffer|ArrayBuffer|Buffer[])} data The message
 * @private
 */


function receiverOnMessage(data) {
  // if (typeof data === 'string') {
  // ziti._ctx.logger.info('ZitiWebSocketWrapper.receiverOnMessage() entered, emitting STRING: %o', data);
  this[kWebSocket].emit('message', data); // } else {
  // let blob = new Blob([new Uint8Array(data, 0, data.byteLength)]);
  // ziti._ctx.logger.info('ZitiWebSocketWrapper.receiverOnMessage() entered, emitting BLOB: %o', blob);
  // this[kWebSocket].emit('message', blob);
  // }
}
/**
 * The listener of the `Receiver` `'ping'` event.
 *
 * @param {Buffer} data The data included in the ping frame
 * @private
 */


function receiverOnPing(data) {
  var websocket = this[kWebSocket];
  websocket.pong(data, !websocket._isServer, NOOP);
  websocket.emit('ping', data);
}
/**
 * The listener of the `Receiver` `'pong'` event.
 *
 * @param {Buffer} data The data included in the pong frame
 * @private
 */


function receiverOnPong(data) {
  this[kWebSocket].emit('pong', data);
}
/**
* The listener of the `net.Socket` `'close'` event.
*
* @private
*/


function socketOnClose() {
  // ziti._ctx.logger.info('ZitiWebSocketWrapper socketOnClose entered');
  var websocket = this[kWebSocket];
  this.removeListener('close', socketOnClose);
  this.removeListener('end', socketOnEnd);
  websocket.readyState = ZitiWebSocketWrapper.CLOSING; //
  // The close frame might not have been received or the `'end'` event emitted,
  // for example, if the socket was destroyed due to an error. Ensure that the
  // `receiver` stream is closed after writing any remaining buffered data to
  // it. If the readable side of the socket is in flowing mode then there is no
  // buffered data as everything has been already written and `readable.read()`
  // will return `null`. If instead, the socket is paused, any possible buffered
  // data will be read as a single chunk and emitted synchronously in a single
  // `'data'` event.
  //

  websocket._socket.read();

  websocket._receiver.end();

  this.removeListener('data', socketOnData);
  this[kWebSocket] = undefined;
  clearTimeout(websocket._closeTimer);

  if (websocket._receiver._writableState.finished || websocket._receiver._writableState.errorEmitted) {
    websocket.emitClose();
  } else {
    websocket._receiver.on('error', receiverOnFinish);

    websocket._receiver.on('finish', receiverOnFinish);
  }
}
/**
 * The listener of the `net.Socket` `'data'` event.
 *
 * @param {Buffer} chunk A chunk of data
 * @private
 */


function socketOnData(chunk) {
  // ziti._ctx.logger.info('ZitiWebSocketWrapper socketOnData entered');
  if (!this[kWebSocket]._receiver.write(chunk)) {
    this.pause();
  }
}
/**
 * The listener of the `net.Socket` `'end'` event.
 *
 * @private
 */


function socketOnEnd() {
  // ziti._ctx.logger.debug('ZitiWebSocketWrapper socketOnEnd entered');
  var websocket = this[kWebSocket];
  websocket.readyState = ZitiWebSocketWrapper.CLOSING;

  websocket._receiver.end();

  this.end();
}
/**
 * The listener of the `net.Socket` `'error'` event.
 *
 * @private
 */


function socketOnError() {
  // ziti._ctx.logger.debug('ZitiWebSocketWrapper socketOnError entered');
  var websocket = this[kWebSocket];
  this.removeListener('error', socketOnError);
  this.on('error', NOOP);

  if (websocket) {
    websocket.readyState = ZitiWebSocketWrapper.CLOSING;
    this.destroy();
  }
}